﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp28
{
    abstract class Teleso
    {
        /// <summary>
        /// Vyska telesa
        /// </summary>
        public double Vyska;

        /// <summary>
        /// Konstruktor
        /// </summary>
        /// <param name="v">Vyska telesa</param>
        public Teleso(double v)
        {
            Vyska = v;
        }

        public Teleso()
        {

        }

        /// <summary>
        /// Vypise informace o telese
        /// </summary>
        public void Vypis()
        {
            //Console.WriteLine("Vyska: " + Vyska + " " + DalsiRozmery() + " Objem: " + ObjemTelesa() + " Povrch: " + PovrchTelesa());
            //Console.WriteLine(ToString());
            Console.WriteLine(this);
        }

        public virtual string DalsiRozmery()
        {
            return "";
        }

        public virtual double ObsahPodstavy()
        {
            return 0;
        }

        public double ObjemTelesa()
        {
            return ObsahPodstavy() * Vyska;
        }

        public virtual double ObvodPodstavy()
        {
            return 0;
        }

        /// <summary>
        /// Vypocte povrch telesa
        /// </summary>
        /// <returns>Povrch telesa</returns>
        public double PovrchTelesa()
        {
            return 2 * ObsahPodstavy() + ObvodPodstavy() * Vyska;
        }

        public override string ToString()
        {
            return "Vyska: " + Vyska + " " + DalsiRozmery() + " Objem: " + ObjemTelesa() + " Povrch: " + PovrchTelesa();
        }
    }
}
